diff --git a/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/Element.java b/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/Element.java
new file mode 100644
index 000000000..809e1e305
--- /dev/null
+++ b/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/Element.java
@@ -0,0 +1,167 @@
+package org.useless.dragonfly.data.block.mojang;
+
+import com.google.gson.JsonDeserializationContext;
+import com.google.gson.JsonDeserializer;
+import com.google.gson.JsonElement;
+import com.google.gson.JsonObject;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonSerializationContext;
+import com.google.gson.JsonSerializer;
+import net.minecraft.core.util.helper.Direction;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.util.GsonHelper;
+
+import java.lang.reflect.Type;
+import java.util.HashMap;
+import java.util.Locale;
+import java.util.Map;
+
+public class Element {
+    protected static final boolean DEFAULT_SHADE = true;
+    protected static final int DEFAULT_LIGHT_EMISSION = 0;
+
+    public final float fromX;
+    public final float fromY;
+    public final float fromZ;
+
+    public final float toX;
+    public final float toY;
+    public final float toZ;
+
+    /**
+     *  Defines the rotation of an element.
+     */
+    public final @Nullable Rotation rotation;
+
+    /**
+     * Defines if shadows are rendered (true - default), not (false).
+     */
+    public final boolean shade;
+    /**
+     * Defines the minimum light level that the element can receive. Can be 0-15, defaults to 0.
+     */
+    public final int lightEmission;
+    public final @NotNull Map<@NotNull Direction, @NotNull Face> faces;
+
+    protected Element(
+        float fromX, float fromY, float fromZ,
+        float toX, float toY, float toZ,
+        @Nullable Rotation rotation,
+        boolean shade,
+        int lightEmission,
+        @NotNull Map<@NotNull Direction, @NotNull Face> faces)
+    {
+        this.fromX = fromX;
+        this.fromY = fromY;
+        this.fromZ = fromZ;
+        this.toX = toX;
+        this.toY = toY;
+        this.toZ = toZ;
+        this.rotation = rotation;
+        this.shade = shade;
+        this.lightEmission = lightEmission;
+        this.faces = faces;
+    }
+
+    @Override
+    public String toString() {
+        return "Element{" +
+            "fromX=" + fromX +
+            ", fromY=" + fromY +
+            ", fromZ=" + fromZ +
+            ", toX=" + toX +
+            ", toY=" + toY +
+            ", toZ=" + toZ +
+            ", rotation=" + rotation +
+            ", shade=" + shade +
+            ", lightEmission=" + lightEmission +
+            ", faces=" + faces +
+            '}';
+    }
+
+    @SuppressWarnings("unused")
+    public static class Builder {
+        protected final float fromX;
+        protected final float fromY;
+        protected final float fromZ;
+        protected final float toX;
+        protected final float toY;
+        protected final float toZ;
+
+        protected @Nullable Rotation rotation = null;
+        protected boolean shade = DEFAULT_SHADE;
+        protected int lightEmission = DEFAULT_LIGHT_EMISSION;
+        protected final @NotNull Map<@NotNull Direction, Face. @NotNull Builder> faces = new HashMap<>();
+
+        public Builder(float fromX, float fromY, float fromZ,
+                       float toX, float toY, float toZ) {
+            this.fromX = fromX;
+            this.fromY = fromY;
+            this.fromZ = fromZ;
+            this.toX = toX;
+            this.toY = toY;
+            this.toZ = toZ;
+        }
+
+        public @NotNull Builder setRotation(@Nullable Rotation.Builder rotation) {
+            this.rotation = rotation == null ? null : rotation.build();
+            return this;
+        }
+
+        public @NotNull Builder setShade(boolean shade) {
+            this.shade = shade;
+            return this;
+        }
+
+        public @NotNull Builder setLightEmission(int lightEmission) {
+            this.lightEmission = lightEmission;
+            return this;
+        }
+
+        public @NotNull Builder addFace(@NotNull Direction direction, Face. @NotNull Builder face) {
+            faces.put(direction, face);
+            return this;
+        }
+
+        protected @NotNull Element build() {
+            Map<Direction, Face> faceMap = new HashMap<>();
+            for (Map.Entry<Direction, Face.Builder> e : faces.entrySet()) {
+                faceMap.put(e.getKey(), e.getValue().build(fromX, fromY, fromZ, toX, toY, toZ, e.getKey()));
+            }
+            return new Element(
+                fromX, fromY, fromZ,
+                toX, toY, toZ,
+                rotation,
+                shade,
+                lightEmission,
+                faceMap);
+        }
+
+        public static class Serializer implements JsonSerializer<Builder>, JsonDeserializer<Builder> {
+
+            @Override
+            public Builder deserialize(JsonElement json, Type typeOfT, JsonDeserializationContext context) throws JsonParseException {
+                JsonObject object = json.getAsJsonObject();
+                float[] from = GsonHelper.getAsFloatArray(object.get("from"), 3);
+                float[] to = GsonHelper.getAsFloatArray(object.get("to"), 3);
+                Builder builder = new Builder(from[0], from[1], from[2], to[0], to[1], to[2]);
+                if (object.has("rotation")) builder.setRotation(context.deserialize(object.get("rotation"), Rotation.Builder.class));
+                if (object.has("shade")) builder.setShade(object.get("shade").getAsBoolean());
+                if (object.has("light_emission")) builder.setLightEmission(object.get("light_emission").getAsInt());
+                JsonObject faces = object.getAsJsonObject("faces");
+                for (Map.Entry<String, JsonElement> e : faces.entrySet()) {
+                    builder.addFace(Direction.valueOf(e.getKey().toUpperCase(Locale.ROOT)), context.deserialize(e.getValue(), Face.Builder.class));
+                }
+                return builder;
+            }
+
+            @Override
+            public JsonElement serialize(Builder src, Type typeOfSrc, JsonSerializationContext context) {
+                throw new UnsupportedOperationException();
+            }
+
+
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/Face.java b/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/Face.java
new file mode 100644
index 000000000..4e73e6f42
--- /dev/null
+++ b/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/Face.java
@@ -0,0 +1,223 @@
+package org.useless.dragonfly.data.block.mojang;
+
+import com.google.gson.JsonDeserializationContext;
+import com.google.gson.JsonDeserializer;
+import com.google.gson.JsonElement;
+import com.google.gson.JsonObject;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonSerializationContext;
+import com.google.gson.JsonSerializer;
+import net.minecraft.core.util.helper.Direction;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.util.GsonHelper;
+
+import java.lang.reflect.Type;
+import java.util.Locale;
+
+public class Face {
+    protected static final int DEFAULT_ROTATION = 0;
+    protected static final int DEFAULT_TINT_INDEX = -1;
+
+    public final float u1;
+    public final float u2;
+    public final float v1;
+    public final float v2;
+
+    /**
+     * Specifies the texture in form of the texture variable prepended with a <code>#</code>.
+     */
+    public final String texture;
+    /**
+     * Specifies whether a face does not need to be rendered when there is a block touching it in the specified position.
+     * The position can any {@link Direction}.
+     * It also determines the side of the block to use the light level from for lighting the face, and if unset, defaults to the side.
+     */
+    public final @Nullable Direction cullFace;
+
+    /**
+     * Rotates the texture clockwise by the specified number of degrees. Can be 0, 90, 180, or 270. Defaults to 0.
+     * Rotation does not affect which part of the texture is used.
+     * Instead, it amounts to permutation of the selected texture vertexes (selected implicitly, or explicitly though uv).
+     */
+    public final int rotation;
+
+    /**
+     * Determines whether to tint the texture using a hardcoded tint index.
+     * The default value, -1, indicates not to use the tint.
+     * Any other number is provided to BlockColors to get the tint value corresponding to that index.
+     * However, most blocks do not have a tint value defined (in which case white is used).
+     */
+    public final int tintIndex;
+
+    protected Face(float u1, float u2, float v1, float v2, @NotNull String texture, @Nullable Direction cullFace, int rotation, int tintIndex) {
+        this.u1 = u1;
+        this.u2 = u2;
+        this.v1 = v1;
+        this.v2 = v2;
+        this.texture = texture;
+        this.cullFace = cullFace;
+        this.rotation = rotation;
+        this.tintIndex = tintIndex;
+    }
+
+    @Override
+    public String toString() {
+        return "Face{" +
+            "u1=" + u1 +
+            ", u2=" + u2 +
+            ", v1=" + v1 +
+            ", v2=" + v2 +
+            ", texture='" + texture + '\'' +
+            ", cullFace=" + cullFace +
+            ", rotation=" + rotation +
+            ", tintIndex=" + tintIndex +
+            '}';
+    }
+
+    @SuppressWarnings("unused")
+    public static class Builder {
+        protected @Nullable Float u1 = null;
+        protected @Nullable Float u2 = null;
+        protected @Nullable Float v1 = null;
+        protected @Nullable Float v2 = null;
+
+        protected boolean mirrorU = false;
+        protected boolean mirrorV = false;
+
+        protected final @NotNull String texture;
+        protected @Nullable Direction cullFace = null;
+        protected int rotation = DEFAULT_ROTATION;
+        protected int tintIndex = DEFAULT_TINT_INDEX;
+
+        public Builder(@NotNull String texture) {
+            this.texture = texture;
+        }
+
+        public @NotNull Builder setUVs(float u1, float v1, float u2, float v2) {
+            this.u1 = u1;
+            this.u2 = u2;
+            this.v1 = v1;
+            this.v2 = v2;
+            return this;
+        }
+
+        public @NotNull Builder setMirrorU(boolean mirrorU) {
+            this.mirrorU = mirrorU;
+            return this;
+        }
+
+        public @NotNull Builder setMirrorV(boolean mirrorV) {
+            this.mirrorV = mirrorV;
+            return this;
+        }
+
+        public @NotNull Builder setCullFace(@NotNull Direction cullFace) {
+            this.cullFace = cullFace;
+            return this;
+        }
+
+        public @NotNull Builder setRotation(int rotation) {
+            this.rotation = rotation;
+            return this;
+        }
+
+        public @NotNull Builder setTintIndex(int tintIndex) {
+            this.tintIndex = tintIndex;
+            return this;
+        }
+
+        protected @NotNull Face build(float fromX, float fromY, float fromZ, float toX, float toY, float toZ, @NotNull Direction sideFacing) {
+            float x1;
+            float x2;
+            float y1;
+            float y2;
+            if (u1 == null || u2 == null || v1 == null || v2 == null) {
+                switch (sideFacing) {
+                    case UP:
+                        x1 = fromX;
+                        x2 = toX;
+                        y1 = fromZ;
+                        y2 = toZ;
+                        break;
+                    case DOWN:
+                        x1 = fromX;
+                        x2 = toX;
+                        y1 = BlockModelMojangData.UNITS_PER_BLOCK - toZ;
+                        y2 = BlockModelMojangData.UNITS_PER_BLOCK - fromZ;
+                        break;
+                    case NORTH:
+                        x1 = BlockModelMojangData.UNITS_PER_BLOCK - toX;
+                        x2 = BlockModelMojangData.UNITS_PER_BLOCK - fromX;
+                        y1 = BlockModelMojangData.UNITS_PER_BLOCK - toY;
+                        y2 = BlockModelMojangData.UNITS_PER_BLOCK - fromY;
+                        break;
+                    case SOUTH:
+                        x1 = fromX;
+                        x2 = toX;
+                        y1 = BlockModelMojangData.UNITS_PER_BLOCK - toY;
+                        y2 = BlockModelMojangData.UNITS_PER_BLOCK - fromY;
+                        break;
+                    case WEST:
+                        x1 = fromZ;
+                        x2 = toZ;
+                        y1 = BlockModelMojangData.UNITS_PER_BLOCK - toY;
+                        y2 = BlockModelMojangData.UNITS_PER_BLOCK - fromY;
+                        break;
+                    case EAST:
+                        x1 = BlockModelMojangData.UNITS_PER_BLOCK - toZ;
+                        x2 = BlockModelMojangData.UNITS_PER_BLOCK - fromZ;
+                        y1 = BlockModelMojangData.UNITS_PER_BLOCK - toY;
+                        y2 = BlockModelMojangData.UNITS_PER_BLOCK - fromY;
+                        break;
+                    default:
+                        x1 = 0;
+                        x2 = BlockModelMojangData.UNITS_PER_BLOCK;
+                        y1 = 0;
+                        y2 = BlockModelMojangData.UNITS_PER_BLOCK;
+                }
+            } else {
+                x1 = u1;
+                x2 = u2;
+                y1 = v1;
+                y2 = v2;
+            }
+
+            if (mirrorU) {
+                float _x = x2;
+                x2 = x1;
+                x1 = _x;
+            }
+
+            if (mirrorV) {
+                float _y = y2;
+                y2 = y1;
+                y1 = _y;
+            }
+
+            return new Face(x1, x2, y1, y2, texture, cullFace, rotation, tintIndex);
+        }
+
+        public static class Serializer implements JsonSerializer<Builder>, JsonDeserializer<Builder> {
+
+            @Override
+            public Builder deserialize(JsonElement json, Type typeOfT, JsonDeserializationContext context) throws JsonParseException {
+                JsonObject object = json.getAsJsonObject();
+                Builder builder = new Builder(object.get("texture").getAsString());
+                if (object.has("uv")) {
+                    float[] uvs = GsonHelper.getAsFloatArray(object.get("uv"), 4);
+                    builder.setUVs(uvs[0], uvs[1], uvs[2], uvs[3]);
+                }
+                if (object.has("cullface")) builder.setCullFace(Direction.valueOf(object.get("cullface").getAsString().toUpperCase(Locale.ROOT)));
+                if (object.has("rotation")) builder.setRotation(object.get("rotation").getAsInt());
+                if (object.has("tintindex")) builder.setTintIndex(object.get("tintindex").getAsInt());
+                return builder;
+            }
+
+            @Override
+            public JsonElement serialize(Builder src, Type typeOfSrc, JsonSerializationContext context) {
+                throw new UnsupportedOperationException();
+            }
+        }
+    }
+}
diff --git a/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/Rotation.java b/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/Rotation.java
new file mode 100644
index 000000000..383cd4897
--- /dev/null
+++ b/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/Rotation.java
@@ -0,0 +1,109 @@
+package org.useless.dragonfly.data.block.mojang;
+
+import com.google.gson.JsonDeserializationContext;
+import com.google.gson.JsonDeserializer;
+import com.google.gson.JsonElement;
+import com.google.gson.JsonObject;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonSerializationContext;
+import com.google.gson.JsonSerializer;
+import net.minecraft.core.util.helper.Axis;
+import org.jetbrains.annotations.NotNull;
+import org.useless.util.GsonHelper;
+
+import java.lang.reflect.Type;
+import java.util.Locale;
+import java.util.Objects;
+
+public class Rotation {
+    protected static final boolean DEFAULT_RESCALE = false;
+
+    public final float originX;
+    public final float originY;
+    public final float originZ;
+
+    /**
+     * Specifies the direction of rotation
+     */
+    public final Axis axis;
+
+    /**
+     * Specifies the angle of rotation.
+     */
+    public final float angle;
+
+    /**
+     * Specifies whether or not to scale the faces across the whole block. Can be true or false. Defaults to false
+     */
+    public final boolean rescale;
+
+    protected Rotation(float originX, float originY, float originZ, @NotNull Axis axis, float angle, boolean rescale) {
+        this.originX = originX;
+        this.originY = originY;
+        this.originZ = originZ;
+        this.axis = axis;
+        this.angle = angle;
+        this.rescale = rescale;
+    }
+
+    @Override
+    public String toString() {
+        return "Rotation{" +
+            "originX=" + originX +
+            ", originY=" + originY +
+            ", originZ=" + originZ +
+            ", axis=" + axis +
+            ", angle=" + angle +
+            ", rescale=" + rescale +
+            '}';
+    }
+
+    @SuppressWarnings("unused")
+    public static class Builder {
+        protected final float originX;
+        protected final float originY;
+        protected final float originZ;
+        protected final @NotNull Axis axis;
+        protected final float angle;
+
+        public boolean rescale = DEFAULT_RESCALE;
+
+        public Builder(
+            float originX, float originY, float originZ,
+            @NotNull Axis axis,
+            float angle
+        ) {
+            this.originX = originX;
+            this.originY = originY;
+            this.originZ = originZ;
+            this.axis = Objects.requireNonNull(axis);
+            this.angle = angle;
+        }
+
+        public @NotNull Builder setRescale(boolean rescale) {
+            this.rescale = rescale;
+            return this;
+        }
+
+        protected @NotNull Rotation build() {
+            return new Rotation(originX, originY, originZ, axis, angle, rescale);
+        }
+
+        public static class Serializer implements JsonSerializer<Rotation.Builder>, JsonDeserializer<Rotation.Builder> {
+
+            @Override
+            public Builder deserialize(JsonElement json, Type typeOfT, JsonDeserializationContext context) throws JsonParseException {
+                JsonObject object = json.getAsJsonObject();
+                float[] origin = GsonHelper.getAsFloatArray(object.get("origin"), 3);
+                Rotation.Builder builder = new Builder(origin[0], origin[1], origin[2], Axis.valueOf(object.get("axis").getAsString().toUpperCase(Locale.ROOT)), object.get("angle").getAsFloat());
+                if (object.has("rescale")) builder.setRescale(object.get("rescale").getAsBoolean());
+                return builder;
+            }
+
+            @Override
+            public JsonElement serialize(Builder src, Type typeOfSrc, JsonSerializationContext context) {
+                throw new UnsupportedOperationException();
+            }
+        }
+    }
+}
diff --git a/game/client/src/main/java/org/useless/dragonfly/models/block/StaticBlockModel.java b/game/client/src/main/java/org/useless/dragonfly/models/block/StaticBlockModel.java
new file mode 100644
index 000000000..4c3804439
--- /dev/null
+++ b/game/client/src/main/java/org/useless/dragonfly/models/block/StaticBlockModel.java
@@ -0,0 +1,50 @@
+package org.useless.dragonfly.models.block;
+
+import net.minecraft.client.render.block.color.BlockColor;
+import net.minecraft.client.render.block.model.BlockModel;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.DisplayPos;
+
+public interface StaticBlockModel {
+
+    /**
+     * @return True if anything rendered, false otherwise
+     */
+    boolean renderStandalone(@NotNull BlockModel<? extends BlockLogic> sourceModel, @NotNull Tessellator tessellator, double x, double y, double z, int metadata, @NotNull BlockColor color, float brightness, float alpha);
+
+    /**
+     * @return True if anything rendered, false otherwise
+     */
+    boolean renderAttached(@NotNull BlockModel<? extends BlockLogic> sourceModel, @NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z, double xOff, double yOff, double zOff, boolean cullFaces, @Nullable IconCoordinate overrideTexture);
+
+    /**
+     * @return Block texture to overlay when inside a block
+     */
+    @Nullable IconCoordinate getOverlay();
+
+    /**
+     * @return Block texture to use for particles when being broken from a specific side
+     */
+    @Nullable IconCoordinate getParticle(@NotNull Side side);
+
+    /**
+     * @return Color index for particle to use from side, default -1 for no color
+     */
+    int particleColorIndex(@NotNull Side side);
+
+    /**
+     * @return Return the render pass to render the model on
+     */
+    int renderLayer();
+
+    /**
+     * @return Return the display position to use for the given id
+     */
+    @NotNull DisplayPos getItemDisplayPos(@NotNull String id);
+}
